(function () {
    if (window.fundH5) {
        return;
    }
    var responseCallbacks = {};
    var uniqueId = 1;

    function setNavigationBarTitle(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.setNavigationBarTitle(jsonStr);
    }

    function setNavigationBarColor(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.setNavigationBarColor(jsonStr);
    }

    function setNavigationBar(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.setNavigationBar(jsonStr);
    }

    function setNavigationStyle(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.setNavigationStyle(jsonStr);
    }

    function setFundH5(isFundH5) {
        fundModule.setFundH5(isFundH5);
    }

    function navigationGoBack(params) {
        fundModule.navigationGoBack();
    }

    /**
     * 提供给native调用. 多次回调
     */
    function _invokeJSCallbackAndKeepAlive(callbackJson) {
        execInvokeMethod(callbackJson);
    }

    /**
     * 提供给native调用. 一次性回调
     */
    function _invokeJSCallback(callbackJson) {
        var callbackId = execInvokeMethod(callbackJson);
        if (callbackId) {
            delete responseCallbacks[callbackId];
        }
    }

    function _postMessageToWeb(jsonData) {
        var messageEvent = document.createEvent("Event");
        messageEvent.initEvent("message", true, true);
        var jsonObject = JSON.parse(jsonData);
        messageEvent.data = jsonObject.data;
        messageEvent.origin = jsonObject.origin;
        window.dispatchEvent(messageEvent);
    }

    function execInvokeMethod(callbackJson) {
        var message = JSON.parse(callbackJson);
        if (message.callbackId) {
            var responseCallback = responseCallbacks[message.callbackId];
            if (!responseCallback) {
                return;
            }

            var res = message;
            responseCallback(res);
            return message.callbackId;
        }
        return undefined;
    }

    function generateCallbackId(params) {
        var convertFunction = function (json) {
            if (params.success || params.fail || params.complete) {
                if (json.code === 1) {
                    params.success ? params.success(json.data) : ''
                } else {
                    params.fail ? params.fail(json.data) : ''
                }
                params.complete ? params.complete(json.data) : json
            }
        };

        var callbackId = 'fund_' + (uniqueId++) + '_' + new Date().getTime();
        responseCallbacks[callbackId] = convertFunction;
        if ((typeof params == 'string') && params.constructor == String) {
            return params;
        } else {
            if (params == undefined) {
                params = {};
            }
            params.callbackId = callbackId;
            return JSON.stringify(params);
        }
    }

    var fundH5 = window.fundH5 = {
        setNavigationBarTitle,
        setNavigationBarColor,
        setNavigationBar,
        setNavigationStyle,
        setFundH5,
        navigationGoBack,
        _postMessageToWeb,
        _invokeJSCallback,
        _invokeJSCallbackAndKeepAlive
    };


    var doc = document;
    var readyEvent = doc.createEvent('Events');
    readyEvent.initEvent('fundJSBridgeReady');
    console.log('before dispatchEvent fundJSBridgeReady');
    window.dispatchEvent(readyEvent);
    console.log('dispatchEvent fundJSBridgeReady');
})();