(function () {
    if (window.fund) {
        return;
    }

    var responseCallbacks = {};
    var uniqueId = 1;

    function setNavigationBarTitle(params){
         var jsonStr = generateCallbackId(params);
         fundModule.setNavigationBarTitle(jsonStr);
     }

    function setNavigationBar(params){
         var jsonStr = generateCallbackId(params);
         fundModule.setNavigationBar(jsonStr);
     }

    function setNavigationBarColor(params){
         var jsonStr = generateCallbackId(params);
         fundModule.setNavigationBarColor(jsonStr);
    }

    function preloadNewsData(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.preloadNewsData(jsonStr);
    }

    function showReplyKeyboard(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.showReplyKeyboard(jsonStr);
    }

    function registerShare(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.registerShare(jsonStr);
    }

    function showShare(params){
        var jsonStr = generateCallbackId(params);
        fundModule.showShare(jsonStr);
    }

    function presentPage(params){
         var jsonStr = generateCallbackId(params);
         fundModule.presentPage(jsonStr);
     }

    function shareWeChat(params){
        var jsonStr = generateCallbackId(params);
        fundModule.shareWeChat(jsonStr);
    }

    function registerCommentShare(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.registerCommentShare(jsonStr);
    }

    function showCommentShare(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.showCommentShare(jsonStr);
    }

    function request(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.request(jsonStr);
    }

    function getUserInfoSync(params) {
        return JSON.parse(fundModule.getUserInfoSync(params));
    }

    function login(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.login(jsonStr);
    }

    function commonLinkTo(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.commonLinkTo(jsonStr);
    }

    function navigateToOrganizationHome(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.navigateToOrganizationHome(jsonStr);
    }

    function updateFollowStatus(params){
        var jsonStr = generateCallbackId(params);
        fundModule.updateFollowStatus(jsonStr);
    }

    function getFollowStatusSync(params){
        var jsonStr = generateCallbackId(params);
        return fundModule.getFollowStatusSync(jsonStr);
    }

    function updateLikeArticleStatus(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.updateLikeArticleStatus(jsonStr);
    }

    function getLikeArticleStatusSync(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.getLikeArticleStatusSync(jsonStr);
    }

    function getCommentDraftSync(params) {
         var jsonStr = generateCallbackId(params);
         return fundModule.getCommentDraftSync(jsonStr);
    }

    function updateReadNewsStatusSync(params) {
         var jsonStr = generateCallbackId(params);
         fundModule.updateReadNewsStatusSync(jsonStr);
    }

    function getReadNewsStatusSync(params) {
         var jsonStr = generateCallbackId(params);
         return fundModule.getReadNewsStatusSync(jsonStr);
    }

    function postMessageToMP(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.postMessageToMP(jsonStr);
    }

    function getEmotionResourceSync(params) {
        var jsonStr = generateCallbackId(params);
        return JSON.parse(fundModule.getEmotionResourceSync(jsonStr));
    }

    function getBigEmotionResourceSync(params) {
        var jsonStr = generateCallbackId(params);
        return JSON.parse(fundModule.getBigEmotionResourceSync(jsonStr));
    }

    function getSystemInfoSync(params){
        var jsonStr = generateCallbackId(params);
        return JSON.parse(fundModule.getSystemInfoSync(jsonStr));
    }

    function previewImage(params){
        var jsonStr = generateCallbackId(params);
        fundModule.previewImage(jsonStr);
    }

    function getUrlConfigSync(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.getUrlConfigSync(jsonStr);
    }

    function refreshView(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.refreshView(jsonStr);
    }

    function reportMonitor(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.reportMonitor(jsonStr);
    }

    function postDelete(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.postDelete(jsonStr);
    }

    /**
     * 提供给native调用. 多次回调
     */
    function _invokeJSCallbackAndKeepAlive(callbackJson) {
        execInvokeMethod(callbackJson);
    }

    /**
     * 提供给native调用. 一次性回调
     */
    function _invokeJSCallback(callbackJson) {
        var callbackId = execInvokeMethod(callbackJson);
        if (callbackId) {
            delete responseCallbacks[callbackId];
        }
    }

    function _postMessageToWeb(jsonData) {
        var messageEvent = document.createEvent("Event");
        messageEvent.initEvent("message", true, true);
        var jsonObject = JSON.parse(jsonData);
        messageEvent.data = jsonObject.data;
        messageEvent.origin = jsonObject.origin;
        window.dispatchEvent(messageEvent);
    }

    function showBottomRewardView(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.showBottomRewardView(jsonStr);
    }

    function showToast(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.showToast(jsonStr);
    }

    function showTitleUserInfo(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.showTitleUserInfo(jsonStr);
    }

    function commentDeleteSucceed(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.commentDeleteSucceed(jsonStr);
    }

    function execInvokeMethod(callbackJson) {
        var message = JSON.parse(callbackJson);
        if (message.callbackId) {
            var responseCallback = responseCallbacks[message.callbackId];
            if (!responseCallback) {
                return;
            }

            var res = message;
            responseCallback(res);
            return message.callbackId;
        }
        return undefined;
    }

    function generateCallbackId(params) {
        var convertFunction = function (json) {
            if (params.success || params.fail || params.complete) {
                if (json.code === 1) {
                    params.success ? params.success(json.data) : ''
                } else {
                    params.fail ? params.fail(json.data) : ''
                }
                params.complete ? params.complete(json.data) : json
            }
        };

        var callbackId = 'fund_' + (uniqueId++) + '_' + new Date().getTime();
        responseCallbacks[callbackId] = convertFunction;
        if ((typeof params == 'string') && params.constructor == String) {
            return params;
        } else {
            if (params == undefined) {
                params = {};
            }
            params.callbackId = callbackId;
            return JSON.stringify(params);
        }
    }

    var fund = window.fund = {
        setNavigationBarTitle,
        setNavigationBar,
        setNavigationBarColor,
        getSystemInfoSync,
        getFollowStatusSync,
        registerShare,
        shareWeChat,
        showShare,
        presentPage,
        registerCommentShare,
        showCommentShare,
        updateFollowStatus,
        getLikeArticleStatusSync,
        updateLikeArticleStatus,
        getCommentDraftSync,
        updateReadNewsStatusSync,
        getReadNewsStatusSync,
        commonLinkTo,
        login,
        showBottomRewardView,
        showToast,
        navigateToOrganizationHome,
        getUserInfoSync,
        request,
        preloadNewsData,
        showReplyKeyboard,
        postMessageToMP,
        getEmotionResourceSync,
        getBigEmotionResourceSync,
        previewImage,
        getUrlConfigSync,
        refreshView,
        reportMonitor,
        showTitleUserInfo,
        postDelete,
        commentDeleteSucceed,
        _postMessageToWeb,
        _invokeJSCallback,
        _invokeJSCallbackAndKeepAlive
    };

    var doc = document;
    var readyEvent = doc.createEvent('Events');
    readyEvent.initEvent('fundJSBridgeReady');
    window.dispatchEvent(readyEvent);
})();